/* copyright  by Stefan Voitel, 2003 - all rights reserved                   */
/* eMail : stefan.voitel@winways.de                                           */

#ifndef _AgentNotifySink_h_
#define _AgentNotifySink_h_

#pragma warning (push)

#include "AgtSvr.h"
#include "Queue.hpp"

class cAgent;

class cAgentSink : private IAgentNotifySinkEx , public cQueue {

public:

   cAgentSink (cAgent *agent);
  ~cAgentSink (void);
      
   bool HasQueuedCommands  (void)  {return ! IsEmpty() || ! Trigger;}
      
private:

   ULONG       RefCount;
   cAgent     *Agent;

   HANDLE      ExecThreadHandle; 
   bool        ExecThreadHasInitialized;
   
   // indicates a Command from queue has been executed
   // would be set from Command immediately or through RequestComplete()
   bool        Trigger; 

   // create interfaces, controls the queue, execute commands
   static DWORD WINAPI  ExecThread   (void *cAgentSinkObject);

   // set trigger when command is removed from Characters queue.
   STDMETHODIMP RequestComplete      (long dwRequestID,long hrStatus);
      
   // Events from Agent, call virtual funktions from cAgent
   STDMETHODIMP Click                (long dwCharID,short fwKeys,long X,long Y);
   STDMETHODIMP DblClick             (long dwCharID,short fwKeys,long X,long Y);
   STDMETHODIMP BookMark             (long dwBookMarkID);


   #pragma warning (disable : 4100)
   #define EMPTYPROC(proc) virtual STDMETHODIMP proc {return NOERROR;}
   EMPTYPROC (Command                (long dwCommandID,IUnknown *punkUserInput))
   EMPTYPROC (RequestStart           (long dwRequestID))
   EMPTYPROC (ActiveClientChange     (long dwCharID,long lStatus))
   EMPTYPROC (ActivateInputState     (long dwCharID,long bActivated))
   EMPTYPROC (VisibleState           (long dwCharID,long bVisible,long lCause))
   EMPTYPROC (BalloonVisibleState    (long dwCharID,long bVisible))
   EMPTYPROC (ListeningState         (long dwCharID,long bListenState,long dwCause))
   EMPTYPROC (Idle                   (long dwCharID,long bStart))
   EMPTYPROC (Move                   (long dwCharID,long X,long Y,long lCause))
   EMPTYPROC (Size                   (long dwCharID,long lWidth,long lHeight))
   EMPTYPROC (DragStart              (long dwCharID,short fwKeys,long X,long Y))
   EMPTYPROC (DragComplete           (long dwCharID,short fwKeys,long X,long Y))
   EMPTYPROC (HelpComplete           (long dwCharID,long dwCommandID,long dwCause))
   EMPTYPROC (Restart                (void))
   EMPTYPROC (Shutdown               (void))
   EMPTYPROC (AgentPropertyChange    (void))
   EMPTYPROC (DefaultCharacterChange (BSTR bszGUID))
   #undef EMPTYPROC

   STDMETHODIMP         QueryInterface    (REFIID,LPVOID FAR*);
   STDMETHODIMP_(ULONG) AddRef            ();
   STDMETHODIMP_(ULONG) Release           ();

   STDMETHODIMP         GetTypeInfoCount  (UINT*);
   STDMETHODIMP         GetTypeInfo       (UINT,LCID,ITypeInfo**);
   STDMETHODIMP         GetIDsOfNames     (REFIID,OLECHAR**,UINT,LCID,DISPID*);
   STDMETHODIMP         Invoke            (DISPID,REFIID,LCID,WORD,DISPPARAMS*,
	                                                   VARIANT*,EXCEPINFO*,UINT*);
};
#pragma warning (pop)
#endif